/*
	propertyInfo.jsx
	Out layer properties To ESTK JSconsole 
	by hTaka
*/

targetComp = app.project.activeItem;
targetLayer = app.project.activeItem.selectedLayers[0];
if(targetLayer != null){
	$.writeln("Selected Layer named \"" +targetLayer.name+"\", has " + targetLayer.numProperties + " properties.")
	for(i=0;i < targetLayer.numProperties;i++){
		$.writeln("#" + targetLayer.property(i+1).propertyIndex + " Name(MatchName): " + targetLayer.property(i+1).name + "(" + targetLayer.property(i+1).matchName+")");
		if(targetLayer.property(i+1).propertyType == PropertyType.NAMED_GROUP){
			$.writeln("-- has following "+ targetLayer.property(i+1).numProperties +" properties");
			for(j=0;j < targetLayer.property(i+1).numProperties;j++){
				$.writeln("\t #" + targetLayer.property(i+1).property(j+1).propertyIndex+ " Name(MatchName): " + targetLayer.property(i+1).property(j+1).name + "(" + targetLayer.property(i+1).property(j+1).matchName+")");
			}
		}
		if(targetLayer.property(i+1).propertyType == PropertyType.INDEXED_GROUP){
			$.writeln("-- "+ targetLayer.property(i+1).numProperties +" index");
			//INDEXED_GROUPS(mask,effects,etc..) processed here.
			//if Effect Property Group
			if(targetLayer.property(i+1).matchName == "ADBE Effect Parade"){
				for(j=0;j < targetLayer.property(i+1).numProperties;j++){
					$.writeln("\t #" + targetLayer.property(i+1).property(j+1).propertyIndex+ " Name(MatchName): " + targetLayer.property(i+1).property(j+1).name + "(" + targetLayer.property(i+1).property(j+1).matchName+")");
					for(k=0;k < targetLayer.property(i+1).property(j+1).numProperties;k++){
						$.writeln("\t\t #" + targetLayer.property(i+1).property(j+1).property(k+1).propertyIndex+ " Name(MatchName): " + targetLayer.property(i+1).property(j+1).property(k+1).name + "(" + targetLayer.property(i+1).property(j+1).property(k+1).matchName+")");
					}
				}
			}
		}
	}

	//if propertity is selected
	if(targetLayer.selectedProperties.length != 0){
		$.writeln("-- Selected Property Info --")
		$.writeln("Selected Prop. Name: " + targetLayer.selectedProperties[0].name+"("+ targetLayer.selectedProperties[0].matchName +")");
		$.writeln("Selected Prop. Index: " + targetLayer.selectedProperties[0].propertyIndex);
		$.writeln("Selected Prop. Under: " + targetLayer.selectedProperties[0].propertyGroup().name+"("+ targetLayer.selectedProperties[0].propertyGroup().matchName +")");
	}
}else{
	$.writeln("No Layer Selected!!");
}